/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package v1alpha6

import (
	"context"
	"time"

	v1alpha6 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1alpha6"
	scheme "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-openstack/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// OpenStackClustersGetter has a method to return a OpenStackClusterInterface.
// A group's client should implement this interface.
type OpenStackClustersGetter interface {
	OpenStackClusters(namespace string) OpenStackClusterInterface
}

// OpenStackClusterInterface has methods to work with OpenStackCluster resources.
type OpenStackClusterInterface interface {
	Create(ctx context.Context, openStackCluster *v1alpha6.OpenStackCluster, opts v1.CreateOptions) (*v1alpha6.OpenStackCluster, error)
	Update(ctx context.Context, openStackCluster *v1alpha6.OpenStackCluster, opts v1.UpdateOptions) (*v1alpha6.OpenStackCluster, error)
	UpdateStatus(ctx context.Context, openStackCluster *v1alpha6.OpenStackCluster, opts v1.UpdateOptions) (*v1alpha6.OpenStackCluster, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha6.OpenStackCluster, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha6.OpenStackClusterList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha6.OpenStackCluster, err error)
	OpenStackClusterExpansion
}

// openStackClusters implements OpenStackClusterInterface
type openStackClusters struct {
	client rest.Interface
	ns     string
}

// newOpenStackClusters returns a OpenStackClusters
func newOpenStackClusters(c *InfrastructureV1alpha6Client, namespace string) *openStackClusters {
	return &openStackClusters{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the openStackCluster, and returns the corresponding openStackCluster object, and an error if there is any.
func (c *openStackClusters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha6.OpenStackCluster, err error) {
	result = &v1alpha6.OpenStackCluster{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("openstackclusters").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of OpenStackClusters that match those selectors.
func (c *openStackClusters) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha6.OpenStackClusterList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha6.OpenStackClusterList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("openstackclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested openStackClusters.
func (c *openStackClusters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("openstackclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a openStackCluster and creates it.  Returns the server's representation of the openStackCluster, and an error, if there is any.
func (c *openStackClusters) Create(ctx context.Context, openStackCluster *v1alpha6.OpenStackCluster, opts v1.CreateOptions) (result *v1alpha6.OpenStackCluster, err error) {
	result = &v1alpha6.OpenStackCluster{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("openstackclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(openStackCluster).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a openStackCluster and updates it. Returns the server's representation of the openStackCluster, and an error, if there is any.
func (c *openStackClusters) Update(ctx context.Context, openStackCluster *v1alpha6.OpenStackCluster, opts v1.UpdateOptions) (result *v1alpha6.OpenStackCluster, err error) {
	result = &v1alpha6.OpenStackCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("openstackclusters").
		Name(openStackCluster.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(openStackCluster).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *openStackClusters) UpdateStatus(ctx context.Context, openStackCluster *v1alpha6.OpenStackCluster, opts v1.UpdateOptions) (result *v1alpha6.OpenStackCluster, err error) {
	result = &v1alpha6.OpenStackCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("openstackclusters").
		Name(openStackCluster.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(openStackCluster).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the openStackCluster and deletes it. Returns an error if one occurs.
func (c *openStackClusters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("openstackclusters").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *openStackClusters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("openstackclusters").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched openStackCluster.
func (c *openStackClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha6.OpenStackCluster, err error) {
	result = &v1alpha6.OpenStackCluster{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("openstackclusters").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
